function [Fq, RHS] = grnd(Body, Joint, q, dq, flag)
% function [Fq, RHS] = grnd(Body, Joint, q, dq, flag)
% 
% OhS̕]
% 
% ̐F
%  flag==1: Constraint equation
%  flag==2: Right-hand-side of velocity equations
%  flag==3: Right-hand-side of acceleration equations
% 
% Copyright (C) 2007  Ms, ]䕔 , ŗt  All Rights Reserved.

% FqRHS̃TCY錾
Fq  = zeros(3*Joint.GR.Number, 3*Body.Number);
RHS = zeros(3*Joint.GR.Number, 1);

for k=1:Joint.GR.Number

	i = Joint.GR.Data(k,1);
	
	% Jacobian matrix nonzero entry	
	
	Fq(3*(k-1)+1, 3*(i-1)+1) = 1;
	Fq(3*(k-1)+2, 3*(i-1)+2) = 1;
	Fq(3*(k-1)+3, 3*(i-1)+3) = 1;
	
	% Constraint equation
	if flag==1
		RHS(3*(k-1)+1) = q(i,1) - Body.InitPos(i,1);
		RHS(3*(k-1)+2) = q(i,2) - Body.InitPos(i,2);
		RHS(3*(k-1)+3) = q(i,3) - Body.InitPos(i,3);
	end
	
	% Right-hand-side of velocity/acceleration equation
	if (flag==2 | flag==3)
		RHS(3*(k-1)+1) = 0;
		RHS(3*(k-1)+2) = 0;
		RHS(3*(k-1)+3) = 0;
	end

end

% =================================================================================
% vO̎gp
% 1. {vOуf[^pŁCЕzĂ͂ȂȂD
% 2. {vOуf[^𒘍҂̋ȂcړIŗpĂ͂ȂȂD
% 3. {vOуf[^̉ς́CcړIłȂ莩RłD
% 4. {vOуf[^gp邱Ƃɂ萶QȂǂɂẮCҁC
%    vNҁC(){@BwC()RiЂ͈؂̐ӔC𕉂ȂD
% 5. {vO̒쌠́C{Ғ҂ȂтɃvO҂ɋAD
% =================================================================================