function [Fq, RHS] = rvlt(Body, Joint, q, dq, flag)
% function [Fq, RHS] = rvlt(Body, Joint, q, dq, flag)
% 
% ]WCgS̕]
% 
% ̐F
%  flag==1: Constraint equation
%  flag==2: Right-hand-side of velocity equations
%  flag==3: Right-hand-side of acceleration equations
% 
% Copyright (C) 2007  Ms, ]䕔 , ŗt  All Rights Reserved.

% FqRHS̃TCY錾
Fq  = zeros(2*Joint.RJ.Number, 3*Body.Number);
RHS = zeros(2*Joint.RJ.Number, 1);

for k=1:Joint.RJ.Number
	
	i = Joint.RJ.Data(k,1);
	j = Joint.RJ.Data(k,2);
	
	xpi_xi = Joint.RJ.Data(k,3)*cos(q(i,3)) ... 
		- Joint.RJ.Data(k,4)*sin(q(i,3));
	ypi_yi = Joint.RJ.Data(k,3)*sin(q(i,3)) ...
		+ Joint.RJ.Data(k,4)*cos(q(i,3));
	xpj_xj = Joint.RJ.Data(k,5)*cos(q(j,3)) ...
		- Joint.RJ.Data(k,6)*sin(q(j,3));
	ypj_yj = Joint.RJ.Data(k,5)*sin(q(j,3)) ...
		+ Joint.RJ.Data(k,6)*cos(q(j,3));
	
	% ==================================================================
	% Jacobian Matrix nonzero entries
	
	Fq(2*(k-1)+1, 3*(i-1)+1) =  1.0;
	Fq(2*(k-1)+1, 3*(i-1)+3) = -ypi_yi;
	Fq(2*(k-1)+1, 3*(j-1)+1) = -1.0;
	Fq(2*(k-1)+1, 3*(j-1)+3) =  ypj_yj;
	
	Fq(2*(k-1)+2, 3*(i-1)+2) =  1.0;
	Fq(2*(k-1)+2, 3*(i-1)+3) =  xpi_xi;
	Fq(2*(k-1)+2, 3*(j-1)+2) = -1.0;
	Fq(2*(k-1)+2, 3*(j-1)+3) = -xpj_xj;
	
	% ==================================================================
	% Constraint equation
	if flag==1
		RHS(2*(k-1)+1)= q(i,1)+xpi_xi-q(j,1)-xpj_xj;
		RHS(2*(k-1)+2)= q(i,2)+ypi_yi-q(j,2)-ypj_yj;
	end
	
	% ==================================================================
	% Right-hand-side of velocity equations
	if flag==2
		RHS(2*(k-1)+1)= 0;
		RHS(2*(k-1)+2)= 0;
	end
	
	% ==================================================================
	% Right-hand-side of acceleration equations
	if flag==3
		RHS(2*(k-1)+1) = xpi_xi*dq(i,3)^2 - xpj_xj*dq(j,3)^2;
		RHS(2*(k-1)+2) = ypi_yi*dq(i,3)^2 - ypj_yj*dq(j,3)^2;
	end
end

% =================================================================================
% vO̎gp
% 1. {vOуf[^pŁCЕzĂ͂ȂȂD
% 2. {vOуf[^𒘍҂̋ȂcړIŗpĂ͂ȂȂD
% 3. {vOуf[^̉ς́CcړIłȂ莩RłD
% 4. {vOуf[^gp邱Ƃɂ萶QȂǂɂẮCҁC
%    vNҁC(){@BwC()RiЂ͈؂̐ӔC𕉂ȂD
% 5. {vO̒쌠́C{Ғ҂ȂтɃvO҂ɋAD
% =================================================================================